config/routes.rb
Rails.application.routes.draw do

namespace :admin do
  resources :participants do
    post 'reset', on: :member
  end
  resources :communities do
    resources :participants
  end
  resources :organizations
  resources :ressources
end

scope :path => '/sys', :as => 'sys' do
  resources :memberships, :only => [:index]
  resources :events, :only => [:index] do
    match :fifo, :via => [:get, :post], :on => :collection
  end
  resources :configs, :only => [:index, :create]
  resources :subparticipants, :only => [:index, :show, :create, :update, :destroy]
end

begin
  Ressource.all.each do |r|
    scope :path => "/#{r.namespace}", :as => r.namespace  do
      resources r.ressource.to_sym, :controller => :messages, :only => [:index, :show, :create, :update, :destroy] do
        match :fifo, :via => [:get, :post], :on => :collection
        match :lifo, :via => [:get, :post], :on => :collection
        match :details, :via => [:get], :on => :collection
        match :details, :via => [:get], :on => :member
      end
    end
  end
rescue ActiveRecord::StatementInvalid
  Rails.logger.info "DB error: #{$!}"
end

resources :memberships, :only => [:index]
resources :events, :only => [:index] do
  match :fifo, :via => [:get, :post], :on => :collection
end

get '/admin' => 'admin/participants#index'
root 'admin/participants#default'

end

app/models/message.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
#
# This file is part of ECS.
#
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


class Message < ApplicationRecord

  require 'exceptions'

  has_many :membership_messages
  has_many :memberships, :through => :membership_messages
  has_many :events, :dependent => :destroy
  has_many :community_messages, :dependent => :destroy
  has_many :communities, :through => :community_messages
  has_one  :auth, :dependent => :destroy
  belongs_to :ressource

  scope :for_participant_receiver, lambda {|participant|
    joins(:membership_messages => {:membership => :participant}).
    order('id ASC').
    where(:participants => {:id => participant.id}).
    readonly(false) }

  scope :for_participant_sender, lambda {|participant|
    order('id ASC').
    where(:sender => participant.id).
    readonly(false) }

  scope :for_not_removed, lambda {
    order('id ASC').
    where(:removed => false) }

  scope :for_removed, lambda {
    order('id ASC').
    where(:removed => true) }

  scope :for_resource, lambda {|namespace, name|
    joins(:ressource).
    order('id ASC').
    where(:ressources => {:namespace => namespace, :ressource => name})}

  def self.create__(request, app_namespace, ressource_name, participant)
    transaction do
      message = create! do |arm|
        arm.create_update_helper(request, app_namespace, ressource_name, participant.id)
      end
      MembershipMessage.extract_x_ecs_receiver_communities(request.headers["X-EcsReceiverCommunities"]).each do |cid|
        message.communities << Community.find(cid)
      end
      MembershipMessage.populate_jointable(message,
                                           request.headers["X-EcsReceiverMemberships"],
                                           request.headers["X-EcsReceiverCommunities"],
                                           participant)
      Participant.for_message(message).distinct.each do |p|
        Event.make(:event_type_name => EvType.find(1).name, :participant => p, :message => message)
      end if message.ressource.events
      if app_namespace == 'sys' and ressource_name == 'auths'
        message.post_create_auths_resource(participant)
      end
      message
    end
  rescue ActiveRecord::RecordInvalid
    raise Ecs::InvalidMessageException, $!.to_s
  end

  def update__(request, app_namespace, ressource_name, participant)
    # TODO Optimistic database locking
    raise(Ecs::AuthorizationException, "You are not the original sender of the message.") unless participant.sender?(self)
    transaction do
      create_update_helper(request, app_namespace, ressource_name, participant.id)
      save!
      # NOTE Unit test doesn't pass if we are not explicitely accessing
      # the ActiveRecord::Relation receivers_old and receivers_new, beacause
      # of Rails's "lazy evaluation".
      # ("MessageTest#test_update_receivers [/home/mb7/freelancer/projekte/ecs4/test/models/message_test.rb:56]")
      # With accessing the ActiveRecord::Relation with #to_a we force an evaluation
      # by converting ActiveRecord::Relation to an array of Model-Objects. We could 
      # have done this # also by calling #load!, but would have get back still an
      # ActiveRecord::Relation, which works also.
      receivers_old = Participant.for_message(self).distinct.to_a
      #puts "*** receivers_old: #{receivers_old.inspect}"
      MembershipMessage.de_populate_jointable(self)
      MembershipMessage.populate_jointable(self,
                                           request.headers["X-EcsReceiverMemberships"],
                                           request.headers["X-EcsReceiverCommunities"],
                                           participant)
      receivers_new = Participant.for_message(self).distinct.to_a
      # TODO: if there are only the headers X-EcsReceiverMemberships and
      # X-EcsReceiverCommunities are updated, then we have to generate events only
      # for these new and removed receivers. To distinguish if the message body
      # is untouched we can use the ETag functionality.
      (receivers_new & receivers_old).each do |p|
        # generate updated events
        Event.make(:event_type_name => EvType.find(3).name, :participant => p, :message => self)
      end if self.ressource.events
      (receivers_old - receivers_new).each do |p|
        # generate destroyed events
        Event.make(:event_type_name => EvType.find(2).name, :participant => p, :message => self)
      end if self.ressource.events
      (receivers_new - receivers_old).each do |p|
        # generate created events
        Event.make(:event_type_name => EvType.find(1).name, :participant => p, :message => self)
      end if self.ressource.events
      if app_namespace == 'sys' and ressource_name == 'auths'
        post_create_auths_resource(participant)
      end
      self
    end
  rescue ActiveRecord::RecordInvalid
    raise Ecs::InvalidMessageException, $!.to_s
  end

  def validate
    if content_type.blank? then
      errors.add_to_base("*** You must povide a \"Content-Type\" header. ")
    end
    if body.blank? then
      errors.add_to_base("*** You have to provide a \"http body\". *** ")
    end
    if sender.blank? then
      errors.add_to_base("*** There is no \"sender\"; this is a fatal error; please report this to ecs@freeit.de. *** ")
    end
  end

  # return first messages from fifo/lifo queue
  def self.fifo_lifo_rest(namespace, ressource, participant_id, options={:queue_type => :fifo})
    m = readonly(false).
        joins(:ressource, :membership_messages => { :membership => :participant }).
        where(:participants => { :id => participant_id },
              :ressources => { :namespace => namespace, :ressource => ressource }).
        order(:messages.to_s+".id " + ((options[:queue_type]==:fifo)?'ASC':'DESC')).
        first
  end

  # get a record  out of the message table
  def self.get_record(msg_id, app_namespace, ressource_name)
    outdated_auth_token = nil
    ressource = Ressource.find_by_namespace_and_ressource(app_namespace, ressource_name)
    raise(Ecs::InvalidRessourceUriException, "*** ressource uri error ***") unless ressource
    if app_namespace == 'sys' and ressource_name == 'auths'
      # processing a auths resource
      if msg_id =~ /\D/
        # asking a one touch token with the hash key
        auth = Auth.find_by_one_touch_hash(msg_id)
        if auth
          record = auth.message
        else
          raise ActiveRecord::RecordNotFound, "Invalid auths hash"
        end
      else
        unless record = find_by_id_and_ressource_id(msg_id.to_i, ressource.id)
          raise ActiveRecord::RecordNotFound, "Invalid auths id"
        end
      end
    else
      record = find_by_id_and_ressource_id(msg_id.to_i, ressource.id)
    end
    if !record or record.removed
      raise ActiveRecord::RecordNotFound, "Invalid resource id"
    else
      [record, outdated_auth_token]
    end
  end

  def filter(action_name, app_namespace, ressource_name, params)
    d="filter/#{app_namespace}/#{ressource_name}/#{action_name}/*"
    filters=Dir[d].collect{|f| File.directory?(f) ? f : nil}.compact
    return if filters.empty?
    FILTER_API.params= params
    FILTER_API.record= self
    filters.sort!
    filters.each do |f|
      files= Dir[f+'/*.rb']
      next if files.empty?
      EcsFilter.constants.each {|c| EcsFilter.instance_eval { remove_const c.to_sym } }
      files.each do |e|
        EcsFilter.module_eval IO.read(e)
      end
      eval "EcsFilter::Filter.start"
    end
  rescue Exception
    logger.error "Filter Exception: "+$!.class.to_s+": "+$!.backtrace[0]
    logger.error "Filter Exception: "+$!.message
  end

  # Request body has to be in json format.
  # Preprocess request body if it's a /sys/auths resource.
  # Generate a one touch token (hash)
  def post_create_auths_resource(participant)
    ttl_min = 5.seconds
    ttl = ttl_min + 60.seconds
    unless Mime::Type.lookup(self.content_type).to_sym == :json
      raise Ecs::InvalidMimetypeException, "Body format has to be in JSON"
    end
    begin
      b = JSON.parse(self.body)
    rescue JSON::ParserError
      raise Ecs::InvalidMessageException, "Invalid JSON body"
    end
    bks = b.keys

    # NOTE Assures that there are at least url or realm set -> backward compatibility
    unless bks.include?("url") or bks.include?("realm")
      raise Ecs::InvalidMessageException, "You have to provide realm or url attribute"
    end

    #msg_id = URI.split(b["url"])[5][1..-1].sub(/[^\/]*\/[^\/]*\/(.*)/, '\1').to_i
    #begin
    #  Message.find(msg_id)
    #rescue ActiveRecord::RecordNotFound
    #  raise Ecs::InvalidMessageException, $!.to_s
    #end
    case
      when (!bks.include?("sov") and !bks.include?("eov"))
        b["sov"] = Time.now.xmlschema
        b["eov"] = (Time.now + ttl).xmlschema
      when (bks.include?("sov") and !bks.include?("eov"))
        if Time.parse(b["sov"]) < Time.now
          raise Ecs::InvalidMessageException, 'sov time is younger then current time'
        end
        b["eov"] = (Time.parse(b["sov"]) + ttl).xmlschema
      when (!bks.include?("sov") and bks.include?("eov"))
        if Time.parse(b["eov"]) < (Time.now + ttl_min)
          raise Ecs::InvalidMessageException, 'eov time is too young'
        end
        b["sov"] = Time.now.xmlschema

app/helpers/admin/participants_helper.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
# 
# This file is part of ECS.
# 
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
# 
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


module Admin::ParticipantsHelper

  @queryparams = [[:list_anonymous,:anonymous], [:action_buttons, :actionbuttons]]

  # adds an empty identity object to the p.identities collection. This object
  # ist still not saved. This collection is reused in the form.fields_for method.
  # (form.fields_for :identities ...)
  def setup_participant(participant)
    participant.identities.build
    participant.communities.build
    participant
  end

  def button_to_reset(participant, list_anonymous, action_buttons)
    button_to_reset =  "button_to 'Reset', reset_admin_participant_path(:id => participant,#{(list_anonymous)?":anonymous => true":":anonymous => false"}"
    button_to_reset += ", #{(action_buttons)?":actionbuttons => true":":actionbuttons => false"})"
    button_to_reset += ", :title => 'All messages and events of \"#{h participant.name}\" participant will be deleted. #{(ECS_CONFIG["admin"]["confirm_actions"])?"":"There will be no confirmation !"}'"
    button_to_reset += ", #{(action_buttons)?":disabled => false":":disabled => true"}"
    button_to_reset += ", :confirm => 'Are you sure?'" if ECS_CONFIG["admin"]["confirm_actions"]
    eval button_to_reset
  end

  def button_to_delete(participant, list_anonymous, action_buttons)
    button_to_delete = "button_to 'Delete', admin_participant_path(:id => participant,#{(list_anonymous)?":anonymous => true":":anonymous => false"}"
    button_to_delete += ", #{(action_buttons)?":actionbuttons => true":":actionbuttons => false"})"
    button_to_delete +=", :method => :delete"
    button_to_delete +=", :title => 'The \"#{h participant.name}\" participant will be deleted. #{(ECS_CONFIG["admin"]["confirm_actions"])?"":"There will be no confirmation !"}'"
    button_to_delete += ", #{(action_buttons)?":disabled => false":":disabled => true"}"
    button_to_delete += ", :confirm => 'Are you sure?'" if ECS_CONFIG["admin"]["confirm_actions"]
    eval button_to_delete
  end

  def link_to_actions_toggle_on_off(list_anonymous, action_buttons)
    Rails.logger.info "Admin::ParticipantsHelper#link_to_actions_toggle_on_off actionbuttons = #{action_buttons}"
    link = "link_to #{(action_buttons)?'\'off\'':'\'on\''}, admin_participants_path(#{(list_anonymous)?":anonymous => true":":anonymous => false"}"
    link +=", #{(action_buttons)?":actionbuttons => false":":actionbuttons => true"})"
    unless action_buttons
      session[:link_to_actions_toggle_on_off] = false
    end
    if not session[:link_to_actions_toggle_on_off] and action_buttons
      session[:link_to_actions_toggle_on_off] = true
      unless ECS_CONFIG["admin"]["confirm_actions"]
        flash.now[:notice] = "Action buttons operate in NON CONFIRMATION mode, .i.e. pressing a delete or reset button just do its job without any confirmation. You have been warned ! To change this behaviour, just set \"admin->confirm_actions\" to \"true\" in \"config/ecs_config.yml\"." 
      end
    end
    eval link
  end

  def link_to_anonymous_toggle_on_off(list_anonymous, action_buttons)
  end

  def toggle_query_param(queryparam)
  end

  def link_to_toggle_on_off(ontext, offtext, list_anonymous, action_buttons)
    #link = "link_to #{(action_buttons)?\'offtext\':\'ontext\'}, admin_participants_path(#{(list_anonymous)?":anonymous => true":":anonymous => false"}"
    #link +=", #{(action_buttons)?":actionbuttons => false":":actionbuttons => true"})"
    #eval link
  end

end

app/views/admin/participants/_form.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<% if @participant.errors.any? %>
<div id="error_explanation">
  <h2><%= pluralize(@participant.errors.count, "error") %> prohibited
    this Participant from being updated</h2>
  <ul>
  <% @participant.errors.full_messages.each do |msg| %>
    <li><%= msg %></li>
  <% end %>
  </ul>
</div>
<% end %>

<p><label for="participant_name" class="box2 table-resource-label">Name:</label>
<%= form.text_field :name %></p>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label class="table-resource-label">Description (optional):</label>
</div>
<%= form.text_area :description, :rows => 2 , :style => "width:99.5%" %>
</div>
</div>

<p>
<table>
<tr>
<td><label for="participant_dns" class="box2 table-resource-label">DNS:</label></td>
<td><%= form.text_field :dns %></td>
</tr>
<tr>
<td><label for="participant_email" class="box2 table-resource-label">Email:</label></td>
<td><%= form.text_field :email %></td>
</tr>
</table>
</p>

<p><label for="participant_organization_id" class="box2 table-resource-label">Organization-Abreviation:</label>
<%= form.collection_select(:organization_id, @organizations, :id, :orgtext) %></p>

<p><label for="participant_community_selfrouting" class="box2 table-resource-label">Community Selfrouting:</label>
<%= form.check_box :community_selfrouting %></p>

<p><label for="participant_events_" class="box2 table-resource-label">Events:</label>
<%= form.check_box :events_ %></p>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label class="table-resource-label">Authentication-IDs:</label>
</div>
  <table border="0" frame="box" rules="none" valign="top" width="100%">
    <tr align="left">
      <th style="width:30%">ID:</th>
      <th style="width:60%">Description (optional):</th>
      <th style="width:10%">delete</th>
    </tr>
    <%= form.fields_for :identities do |ident| %>
      <tr align="left" valign="top">
        <td><%= ident.text_field :name, :style => "width:100%" %></td>
        <TD><%= ident.text_area :description, :rows => 1, :style => "width:95%;margin-left:2em" %></TD>
        <% unless ident.object.new_record? %>
            <td valign='middle'>
            <%= ident.check_box :_destroy %>
            <!-- %= ident.label :_delete, 'delete' %> -->
            </td>
        <% else %>
            <td></td>
        <% end %>
      </tr>
    <% end %>
  </table>
</div>
</div>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label class="table-resource-label">Communities:</label>
</div>
  <!-- <table border="1" frame="box" rules="all" valign="top"> -->
  <table class="list" width="100%">
  
    <tr align="left">
      <th>Name:</th>
      <th>Description (optional):</th>
      <th>join</th>
    </tr>
  
    <% @communities.each do |community| %>
  	    <tr valign="top" class="<%= cycle('list-line-odd', 'list-line-even') %>">
  <!--      <tr align="left" valign="top"> -->
          <TD>
            <%= link_to h(community.name), admin_community_path(community) %>
          </TD>
          <TD>
            <%= h(community.description).gsub(/\r\n/,'<BR />') %>
          </TD>
          <td valign='middle'>
            <%= check_box_tag "participant[community_ids][]", community.id, @participant.communities.include?(community) %> 
          </td>
        </tr>
    <% end %>
  </table>
</div>
</div>
</p>

app/views/admin/participants/edit.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Edit Participant</h1>

<P>
<%= link_to 'Show', admin_participant_path(:id => @participant) %> |
<%= link_to 'Back', admin_participants_path %>
</P>
<P>
<%= form_for [:admin, setup_participant(@participant)], :method=>:put do |f| %>
  <p><%= f.submit 'Save' %></p>
  <%= render :partial => f %>
  <p><%= f.submit 'Save' %><p>
<% end %>
</P>

<P>
<%= link_to 'Show', admin_participant_path(:id => @participant) %> |
<%= link_to 'Back', admin_participants_path %>
</P>

app/views/admin/participants/index_communities.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1>Listing Communities of Participant "<%= @participant.name %>" </h1>

<%= link_to 'Back', index_admin_participants_path %><BR><BR>

<%= render(:partial => 'shared/admin/communities',
           :locals  => 
           {  
             :links => 
             [
               { 
                 :text=>"leave Community", 
                 :map_name_function=>'destroy_admin_participant_community_path(:id => @participant.id, :c_id => community.id), :method=>:delete,  :confirm => \'Are you sure?\''
               }
             ]
           }
          ) 
%>

<BR><%= link_to 'Back', index_admin_participants_path %><BR>

app/views/admin/participants/index_noncommunities.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1>Listing Communities to join for Participant "<%= @participant.name %>" </h1>

<%= link_to 'Back', index_admin_participants_path %><BR><BR>

<%= render(:partial => 'shared/admin/communities',
           :locals  => 
           {  
             :links => 
             [
               {
                 :text=>"join Community",
                 :map_name_function=>'create_admin_participant_community_path(:id => @participant.id, :c_id => community.id), :method=>:post'
               }
             ]
           }
          ) 
%>

<BR><%= link_to 'Back', index_admin_participants_path %><BR>

app/views/admin/participants/list.html.haml
-#
  Copyright (C) 2007, 2013 Heiko Bernloehr (FreeIT.de).

  This file is part of ECS.

  ECS is free software: you can redistribute it and/or modify it
  under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of
  the License, or (at your option) any later version.

  ECS is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public
  License along with ECS. If not, see <http://www.gnu.org/licenses/>.


%h1.box1 Listing Participants (#{@list_participants_count.to_s})

.text-link= link_to 'New participant', new_admin_participant_path
- if @list_participants_anonymous_count > 0
  - if @list_anonymous
    .text-link= link_to "Hide anonymous (#{@list_participants_anonymous_count})", admin_participants_path(:anonymous => "false")
  - else
    .text-link= link_to "Show anonymous (#{@list_participants_anonymous_count})", admin_participants_path(:anonymous => "true")

%p
  %table.list
    %tr.table-resource-label
      %th.box2 &uarr; OrgAbrev:
      %th.box2 ID:
      %th.box2 &uarr; Name:
      %th.box2 Description (optional):
      %th.box2 Self-<br/>routing:
      %th.box2 Events:
      %th.box2(align="center")= "Links, Actions (#{link_to_actions_toggle_on_off(@list_anonymous, @action_buttons)})".html_safe
    %tr

    - @participants.group_by(&:organization_id).sort{|x,y| Organization.find(x[0]).abrev.downcase <=> Organization.find(y[0]).abrev.downcase}.each do |orgid,participants|
      - org_printed= false
      - participants.sort{|x,y| x.name.downcase <=> y.name.downcase}.each do |participant|
        %tr{:class => [cycle('list-line-odd', 'list-line-even')]}
          - if org_printed
            %td.center "
          - else
            %td= Organization.find(orgid).abrev
          %td.center= participant.id
          %td= h participant.name
          %td= truncate(participant.description, :length => 80)
          %td.center= check_box_tag "participant[community_selfrouting]",1,participant.community_selfrouting, :disabled => true
          %td.center= check_box_tag "participant[events_]",1,participant.events_, :disabled => true
          %td
            %table
              %tr
                %td
                  = link_to 'Show', admin_participant_path(:id => participant)
                  = link_to 'Edit', edit_admin_participant_path(:id => participant)
                  &nbsp;&nbsp;
                  %td
                    = button_to_reset(participant, @list_anonymous, @action_buttons)
                  %td
                    = button_to_delete(participant, @list_anonymous, @action_buttons)
          - org_printed= true

app/views/admin/participants/new.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">New Participant</h1>

<p>
<%= link_to 'Back', admin_participants_path %>
</p>

<p>
<%= form_for [:admin, @participant] do |f| %>
  <p><%= f.submit "Create" %></p>
  <%= render :partial => f %>
  <p><%= f.submit "Create" %></p>
<% end %>
</p>

<p>
<%= link_to 'Back', admin_participants_path %>
</p>